// AFSKtestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AFSKtest.h"
#include "AFSKtestDlg.h"
#include "slip.h"
#include "rs232.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define MAX_WINDOWCHARS        (20*10)

struct s_HexStr {
	BYTE high;
	BYTE low;
	BYTE space;
};

union u_HexStr {
	struct s_HexStr hexstr[MAX_WINDOWCHARS+1];
	BYTE   str[MAX_WINDOWCHARS+1];
};

const BYTE HexTable[16] = {'0','1','2','3','4','5','6','7',
  						   '8','9','A','B','C','D','E','F'};

#define MTCmd_ACK                   0x40
#define MTCmd_SETPOLARITYnDAC       0x41
#define MTCmd_SETDAC                0x42
#define MTCmd_NAK                   0x4F

#define ECHO_TIMER                  100   
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAFSKtestDlg dialog

CAFSKtestDlg::CAFSKtestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAFSKtestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAFSKtestDlg)
	m_InputFrame = _T("");
	m_SelBaudRate = 3;
	m_SelIdentify = 999;
	m_SelRfChannel = 15;
	m_SelParity = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
//	m_polarityX = 1;
//	m_polarityY = 1;
//	m_polarityZ = 1;

//	m_DAC1 = m_DAC2 = m_DAC3 = 0;

	m_DaAddress = 0x6100;
	m_EchoRunStop = 0;

	m_RdRfChannel = 0xFFFF;
	m_RdParity	  = 0xFFFF;
	m_RdDataRate  = 0xFFFF;
	m_RdIdentify  = 0xFFFF;

	m_TxNum = m_RxNum = 0;
}

void CAFSKtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAFSKtestDlg)
	DDX_Control(pDX, IDC_ECHOREQUEST, m_EchoButton);
	DDX_Control(pDX, IDC_DEFAULT, m_DefaultButton);
	DDX_Control(pDX, IDC_READ, m_ReadButton);
	DDX_Control(pDX, IDC_WRITE, m_WriteButton);
	DDX_Control(pDX, IDC_TESTFRAME, m_SendButton);
	DDX_Control(pDX, IDC_LED3ON, m_Led3OnButton);
	DDX_Control(pDX, IDC_LED3OFF, m_Led3OffButton);
	DDX_Control(pDX, IDC_LED2ON, m_Led2OnButton);
	DDX_Control(pDX, IDC_LED2OFF, m_Led2OffButton);
	DDX_Control(pDX, IDC_LED1ON, m_Led1OnButton);
	DDX_Control(pDX, IDC_LED1OFF, m_Led1OffButton);
	DDX_Control(pDX, IDC_LED3, m_Led3);
	DDX_Control(pDX, IDC_LED2, m_Led2);
	DDX_Control(pDX, IDC_LED1, m_Led1);
	DDX_Text(pDX, IDC_INPUTFRAME, m_InputFrame);
	DDV_MaxChars(pDX, m_InputFrame, 20);
	DDX_Radio(pDX, IDC_BAUDRATE, m_SelBaudRate);
	DDX_Text(pDX, IDC_IDENTIFY2, m_SelIdentify);
	DDV_MinMaxUInt(pDX, m_SelIdentify, 0, 999);
	DDX_Radio(pDX, IDC_RFCHANNEL, m_SelRfChannel);
	DDX_Radio(pDX, IDC_PARITY, m_SelParity);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAFSKtestDlg, CDialog)
	//{{AFX_MSG_MAP(CAFSKtestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RESETRXCNT, OnResetrxcnt)
	ON_BN_CLICKED(IDC_RESETTXCNT, OnResettxcnt)
	ON_BN_CLICKED(IDC_PORTSETTING, OnPortsetting)
	ON_BN_CLICKED(IDC_ECHOREQUEST, OnEchorequest)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_TESTFRAME, OnTestframe)
	ON_BN_CLICKED(IDC_LED1ON, OnLed1on)
	ON_BN_CLICKED(IDC_LED1OFF, OnLed1off)
	ON_BN_CLICKED(IDC_LED2ON, OnLed2on)
	ON_BN_CLICKED(IDC_LED2OFF, OnLed2off)
	ON_BN_CLICKED(IDC_LED3ON, OnLed3on)
	ON_BN_CLICKED(IDC_LED3OFF, OnLed3off)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RECEIVEDATA,OnRxChar)
	ON_MESSAGE(WM_TRANSMITTDATA,OnTxChar)
	ON_MESSAGE(WM_RECEIVEFRAME,OnReceiveFrame)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAFSKtestDlg message handlers

BOOL CAFSKtestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Led1.SetLed(CIrsLed::LED_COLOR_RED    ,CIrsLed::LED_OFF,CIrsLed::LED_SQUARE);
	m_Led2.SetLed(CIrsLed::LED_COLOR_YELLOW ,CIrsLed::LED_OFF,CIrsLed::LED_SQUARE);
	m_Led3.SetLed(CIrsLed::LED_COLOR_GREEN  ,CIrsLed::LED_OFF,CIrsLed::LED_SQUARE);

	// TODO: Add extra initialization here
	SetWindowText("AFSKtest Ver 1.0 2011/03/18   www.wgmsk.com");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAFSKtestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAFSKtestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CAFSKtestDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CAFSKtestDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAFSKtestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAFSKtestDlg::OnResetrxcnt() 
{
	// TODO: Add your control notification handler code here
	m_RxNum = 0;
	SetDlgItemText(IDC_RXNUM, "0");	
}

void CAFSKtestDlg::OnResettxcnt() 
{
	// TODO: Add your control notification handler code here
	m_TxNum = 0;
	SetDlgItemText(IDC_TXNUM, "0");	
}

void CAFSKtestDlg::OnPortsetting() 
{
	// TODO: Add your control notification handler code here
	static const DWORD BaudRate[] = {CBR_1200,CBR_2400,CBR_4800,CBR_9600,CBR_19200,CBR_38400};
	static const int Port[] = {COM1,COM2,COM3,COM4,COM5,COM6};
	static const int DataBits[] = {8,7,6};
	static const int Parity[] = {NOPARITY,ODDPARITY,EVENPARITY};
	static const int StopBits[] = {ONESTOPBIT,TWOSTOPBITS};

	CString temp;

	if(m_SettingDlg.DoModal() == IDOK) {
		m_slip.CloseComPort();
		Sleep(250);

		m_slip.SetCommPort(m_hWnd,Port[m_SettingDlg.m_Port],
			BaudRate[m_SettingDlg.m_BaudRate],
			DataBits[m_SettingDlg.m_DataBits],
			Parity[m_SettingDlg.m_Parity],
			StopBits[m_SettingDlg.m_StopBits]);
			

		if(m_slip.OpenComPort()) {
			temp.Format("Port:COM%d  Baud Rate:%ldbps",Port[m_SettingDlg.m_Port],BaudRate[m_SettingDlg.m_BaudRate]);

			if(m_SettingDlg.m_Parity == 1)
				temp += "  O";
			else if(m_SettingDlg.m_Parity == 2)
				temp += "  E";
			else
				temp += "  N";

			if(m_SettingDlg.m_DataBits == 0)
				temp += ":8";
			else if(m_SettingDlg.m_DataBits == 1)
				temp += ":7";
			else
				temp += ":6";

			if(m_SettingDlg.m_StopBits == 0)
				temp += ":1";
			else
				temp += ":2";

			SetDlgItemText(IDC_PORT_INFO, temp);
			//GetDlgItem(IDC_PORTSETTING)->SetWindowText(temp);

			if( m_SettingDlg.m_BaudRate == 3 &&
				m_SettingDlg.m_DataBits == 0 &&
				m_SettingDlg.m_Parity   == 0 &&
				m_SettingDlg.m_StopBits == 0) {   // 9600bps 8N1
				m_ReadButton.EnableWindow(TRUE);
				m_WriteButton.EnableWindow(TRUE);
				m_DefaultButton.EnableWindow(TRUE);
			}
			else {
				m_ReadButton.EnableWindow(FALSE);
				m_WriteButton.EnableWindow(FALSE);
				m_DefaultButton.EnableWindow(FALSE);
			}

			m_SendButton.EnableWindow(TRUE);

			m_Led1OnButton.EnableWindow(TRUE);
			m_Led1OffButton.EnableWindow(TRUE);

			m_Led2OnButton.EnableWindow(TRUE);
			m_Led2OffButton.EnableWindow(TRUE);

			m_Led3OnButton.EnableWindow(TRUE);
			m_Led3OffButton.EnableWindow(TRUE);

			m_EchoButton.EnableWindow(TRUE);

			SetTestMode();
		}
		else {	
			temp.Format("Cannot open COM%d",Port[m_SettingDlg.m_Port]);
			AfxMessageBox(temp);
			SetDlgItemText(IDC_PORT_INFO, "Port not set");
			//GetDlgItem(IDC_PORTSETTING)->SetWindowText("Port Setting");

			m_ReadButton.EnableWindow(FALSE);
			m_WriteButton.EnableWindow(FALSE);
			m_DefaultButton.EnableWindow(FALSE);

			m_SendButton.EnableWindow(FALSE);

			m_Led1OnButton.EnableWindow(FALSE);
			m_Led1OffButton.EnableWindow(FALSE);

			m_Led2OnButton.EnableWindow(FALSE);
			m_Led2OffButton.EnableWindow(FALSE);

			m_Led3OnButton.EnableWindow(FALSE);
			m_Led3OffButton.EnableWindow(FALSE);

			m_EchoButton.EnableWindow(FALSE);
		}
	}	
}

#define MAX_DISPLAYCHARS       40
	static char s_RxBuffer[MAX_DISPLAYCHARS * 2 + 5];

void CAFSKtestDlg::OnRxChar(WPARAM wParam, LPARAM lParam)
{
	WPARAM len;
	BYTE data,*buffer;
	CString strTemp,Temp;
	static int  s_RxCharCnt = 0;
	int i;
	unsigned char num100,num10,num1;
	
	buffer = (BYTE *)lParam;
	strTemp = RxData[MAX_DISPLAYLINES-1];

	if(m_OpMode == CONFIG_MODE) {
		for(len = 0;len < wParam;len++) {
			data = buffer[len];

			if(data == 0x0A)  
				;
			else if(data == 0x0D) { // ٹٲ 
				if(s_RxBuffer[0] == '%' || s_RxBuffer[0] == '$') {
					if(s_RxCharCnt == 5) {		// %SPxx , %CHxx or %Err
						num10 = s_RxBuffer[3];
						num1  = s_RxBuffer[4];

						if((s_RxBuffer[1] == 'S') && (s_RxBuffer[2] == 'P')) {
							if(('1' <= num10) && (num10 <= '6')) {
								unsigned int BaudRate[] = {
									1200,2400,4800,9600,19200,38400};

								if(num1 == 'N') {
									m_SelParity = 0;
									m_SelBaudRate = (num10 - '0') - 1;
									m_RdParity	  = 'N';
									m_RdDataRate  = BaudRate[m_SelBaudRate];
									UpdateData(FALSE);
								}
								else if(num1 == 'O') {
									m_SelParity = 1;
									m_SelBaudRate = (num10 - '0') - 1;
									m_RdParity	  = 'O';
									m_RdDataRate  = BaudRate[m_SelBaudRate];
									UpdateData(FALSE);
								}
								else if(num1 == 'E') {
									m_SelParity = 2;
									m_SelBaudRate = (num10 - '0') - 1;
									m_RdParity	  = 'E';
									m_RdDataRate  = BaudRate[m_SelBaudRate];
									UpdateData(FALSE);
								}
							}
						}
						else if((s_RxBuffer[1] == 'C') && (s_RxBuffer[2] == 'H')) {
							if(('0' <= num10 && num10 <= '1') && ('0' <= num1 && num1 <= '9')) {
								m_SelRfChannel = (num10 - '0') * 10 + (num1 - '0');								
								m_RdRfChannel  = m_SelRfChannel;
								UpdateData(FALSE);
							}
						}
					}
					else if(s_RxCharCnt == 6) { // %IDxxx
						if(s_RxBuffer[1] == 'I' && s_RxBuffer[2] == 'D') {
							num100 = s_RxBuffer[3];
							num10  = s_RxBuffer[4];
							num1   = s_RxBuffer[5];	

							if(('0' <= num100 && num100 <= '9') && 
							   ('0' <= num10  && num10  <= '9') && 
							   ('0' <= num1   && num1   <= '9')) {
								m_SelIdentify = (num100 - '0') * 100 +
									  (num10 - '0') * 10 +
									  (num1 - '0');
								m_RdIdentify  = m_SelIdentify;
								UpdateData(FALSE);
							}							
						}
					}
					else {						// %Ok or else
						int cnt;

						cnt = s_RxCharCnt;
					}

					if(m_RdIdentify != 0xFFFF && m_RdRfChannel != 0xFFFF && 
						m_RdParity != 0xFFFF && m_RdDataRate != 0xFFFF) {
						CString temp;

						temp.Format("    !!! EEPROM Data !!!    \n\r\n\r"
									"ID: %03d\n\r"
									"UART:%d 8-%c-1\n\r"
									"RF Frequency:",m_RdIdentify,m_RdDataRate,m_RdParity);
						switch(m_RdRfChannel) {
							case 0:		temp += "424.7000MHz";   break;
							case 1:		temp += "424.7125MHz";   break;
							case 2:		temp += "424.7250MHz";   break;
							case 3:		temp += "424.7375MHz";   break;
							case 4:		temp += "424.7500MHz";   break;
							case 5:		temp += "424.7625MHz";   break;
							case 6:		temp += "424.7750MHz";   break;
							case 7:		temp += "424.7875MHz";   break;
							case 8:		temp += "424.8000MHz";   break;
							case 9:		temp += "424.8250MHz";   break;
							case 10:	temp += "424.8500MHz";   break;
							case 11:	temp += "424.8750MHz";   break;
							case 12:	temp += "424.9000MHz";   break;
							case 13:	temp += "424.9250MHz";   break;
							case 14:	temp += "424.9500MHz";   break;
							default:	temp += "424.8000MHz";   break;
						}

						AfxMessageBox(temp);

						m_RdRfChannel = 0xFFFF;
						m_RdParity	  = 0xFFFF;
						m_RdDataRate  = 0xFFFF;
						m_RdIdentify  = 0xFFFF;
					}
				}

				for(i = 0; i < s_RxCharCnt;i++) {
					Temp.Format("%c",s_RxBuffer[i]);
					strTemp += Temp;
				}
				strTemp += "\r\n";
				RxData[MAX_DISPLAYLINES-1] = strTemp;

				for(i=0; i < MAX_DISPLAYLINES-1; i++)
					RxData[i] = RxData[i+1];

				CString RxDataTemp = "";
				strTemp = "";
				RxData[MAX_DISPLAYLINES-1] = "";
				for (i=0; i < MAX_DISPLAYLINES; i++) 
					RxDataTemp += RxData[i];
				
				SetDlgItemText(IDC_RXDATA, RxDataTemp);
				s_RxCharCnt = 0;
			}
			else {
				if(s_RxCharCnt < MAX_DISPLAYCHARS*2) {
					s_RxBuffer[s_RxCharCnt++] = data;
				}
				else {
					for(i = 1; i < MAX_DISPLAYCHARS*2;i++) 
						s_RxBuffer[i-1] = s_RxBuffer[i];
					
					s_RxCharCnt = MAX_DISPLAYCHARS*2-1;
					s_RxBuffer[s_RxCharCnt++] = data;
				}
			}
		}
	}
	else {
		for(len = 0;len < wParam;len++) {	
			data = buffer[len];
		
			// 1ο  ϵ MAX_DISPLAYCHARS ͸ ó (Ver 1.1)
			if(s_RxCharCnt < MAX_DISPLAYCHARS) {
				s_RxBuffer[s_RxCharCnt++] = data;
			}
			else {
				for(i = 1; i < MAX_DISPLAYCHARS;i++) 
					s_RxBuffer[i-1] = s_RxBuffer[i];
				
				s_RxCharCnt = MAX_DISPLAYCHARS-1;
				s_RxBuffer[s_RxCharCnt++] = data;
			}

			if(m_slip.ReceiveFrame(data) >= HEADER_SIZE) {
				for(i = 0; i < s_RxCharCnt;i++) {
					data = s_RxBuffer[i];

					Temp.Format("%c%c ",HexTable[data / 0x10],HexTable[data & 0x0F]);
					strTemp += Temp;
				}
				s_RxCharCnt = 0;

				strTemp += "\r\n";
				RxData[MAX_DISPLAYLINES-1] = strTemp;
				
				Temp.Format("%d",++m_RxNum);
				SetDlgItemText(IDC_RXNUM, Temp);

				for (int i=0; i < MAX_DISPLAYLINES-1; i++)
					RxData[i] = RxData[i+1];

				strTemp = "";
				RxData[MAX_DISPLAYLINES-1] = "";
		
				CString RxDataTemp = "";
				for (i=0; i < MAX_DISPLAYLINES; i++) 
					RxDataTemp += RxData[i];
				
				SetDlgItemText(IDC_RXDATA, RxDataTemp);
			}
		}
	}
}

void CAFSKtestDlg::OnTxChar(WPARAM wParam, LPARAM lParam)
{
	int i;
	WPARAM len;
	BYTE data,*buffer;
	CString strTemp,Temp;

	buffer = (BYTE *)lParam;
	strTemp = TxData[MAX_DISPLAYLINES-1];
	
	if(m_OpMode == CONFIG_MODE) {
		for(len = 0;len < (wParam-1);len++) {
			data = buffer[len];

			Temp.Format("%c",buffer[len]);
			strTemp += Temp;
		}
	}
	else {
		for(len = 0;len < wParam;len++) {	
			data = buffer[len];

			Temp.Format("%c%c ",HexTable[data / 0x10],HexTable[data & 0x0F]);
			strTemp += Temp;
		}

		Temp.Format("%d", ++m_TxNum);
		SetDlgItemText(IDC_TXNUM, Temp);
	}

	strTemp += "\r\n";
	TxData[MAX_DISPLAYLINES-1] = strTemp;

	for (i=0; i < MAX_DISPLAYLINES-1; i++)
		TxData[i] = TxData[i+1];

	TxData[MAX_DISPLAYLINES-1] = "";

	CString TxDataTemp = "";
	for (i=0; i < MAX_DISPLAYLINES; i++) 
		TxDataTemp += TxData[i];
	
	SetDlgItemText(IDC_TXDATA, TxDataTemp);
}

void CAFSKtestDlg::OnReceiveFrame(WPARAM len, LPARAM pFrame)
{
	FRAME *rxframe;
	unsigned char LedNo;
	unsigned char LedOnOff;

	rxframe = (FRAME *)pFrame;
	switch(rxframe->InfoFrame.FT) {
    	case NAK_FRAME:
			break;
		case ACK_FRAME:
			break;
		case LED_ONOFF:
			LedNo    = rxframe->LedOnOffFrame.LedNo;
			LedOnOff = rxframe->LedOnOffFrame.LedOnOff;
			
			if(LedNo == 1) {
				if(LedOnOff) 
					m_Led1.On();
				else
					m_Led1.Off();
			}
			else if(LedNo == 2) {
				if(LedOnOff) 
					m_Led2.On();
				else
					m_Led2.Off();
			}
			else if(LedNo == 3) {
				if(LedOnOff) 
					m_Led3.On();
				else
					m_Led3.Off();
			}
			else {
				;
			}
			break;
		case TEXT_MSG:
			int i;
			char TextMsg[MAX_DISPLAYCHARS+1];

			for(i = 0;;i++) {
				if(i >= MAX_DISPLAYCHARS)
					break;
				else if(rxframe->TextFrame.TextMsg[i] == 0x0D)
					break;
				else if(rxframe->TextFrame.TextMsg[i] == 0x0A)
					break;
				else
					TextMsg[i] = rxframe->TextFrame.TextMsg[i];
			}
//m_slip.SendFrame(i+2 ,rxframe);

			TextMsg[i] = 0; // NULL
			SetDlgItemText(IDC_DISPLAYMSG, TextMsg);
			break;
		default:
			break;
	}
}

void CAFSKtestDlg::OnEchorequest() 
{
	// TODO: Add your control notification handler code here
	if(m_slip.idComDev != NULL && m_EchoRunStop == 0) {
		SetTestMode();

		m_EchoRunStop = 1;
		SetTimer(ECHO_TIMER,100,NULL);
		SetDlgItemText(IDC_ECHOREQUEST, "Tx Test(Stop)");
	}	
	else {
		m_EchoRunStop = 0;
		KillTimer(ECHO_TIMER);
		SetDlgItemText(IDC_ECHOREQUEST, "Tx Test(Run)");
	}
}

void CAFSKtestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	FRAME frame;
	static int s_SeqNo = 0;
	int time;

	if(m_slip.idComDev == NULL) {
		OnEchorequest();
	}
	else if(nIDEvent == ECHO_TIMER) {
		SETHEADER(frame,m_DaAddress,SA_ADDRESS,ECHO_REQUEST);

		frame.InfoFrame.info_ccitt[0]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[1]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[2]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[3]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[4]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[5]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[6]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[7]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[8]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[9]  = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[10] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[11] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[12] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[13] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[14] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[15] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[16] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[17] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[18] = rand() & 0xFF;
		frame.InfoFrame.info_ccitt[19] = rand() & 0xFF;
		m_slip.SendFrame(20 ,&frame);

		KillTimer(ECHO_TIMER);
		time = (rand() & 0x003f) * 50 + 50;
		SetTimer(ECHO_TIMER,time,NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

void CAFSKtestDlg::OnTestframe() 
{
	// TODO: Add your control notification handler code here
	int len,i;
	FRAME frame;

	UpdateData();
	len = m_InputFrame.GetLength();

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,TEXT_MSG);

	for(i=0;i < len;i++) {
		frame.InfoFrame.info_ccitt[i] = m_InputFrame.GetAt(i);
	}
	
	frame.InfoFrame.info_ccitt[i++] = 13;   // CR
	frame.InfoFrame.info_ccitt[i++] = 10;   // LF

	m_slip.SendFrame((len+2) ,&frame);
}

void CAFSKtestDlg::OnLed1on() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 1;
	frame.LedOnOffFrame.LedOnOff = 0x01;   // LED On
	m_slip.SendFrame(2,&frame);
}

void CAFSKtestDlg::OnLed1off() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 1;
	frame.LedOnOffFrame.LedOnOff = 0x00;   // LED On
	m_slip.SendFrame(2,&frame);
}

void CAFSKtestDlg::OnLed2on() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 2;
	frame.LedOnOffFrame.LedOnOff = 0x01;   // LED On
	m_slip.SendFrame(2,&frame);	
}

void CAFSKtestDlg::OnLed2off() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 2;
	frame.LedOnOffFrame.LedOnOff = 0x00;   // LED Off
	m_slip.SendFrame(2,&frame);	
}

void CAFSKtestDlg::OnLed3on() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 3;
	frame.LedOnOffFrame.LedOnOff = 0x01;   // LED On
	m_slip.SendFrame(2,&frame);	
}

void CAFSKtestDlg::OnLed3off() 
{
	// TODO: Add your control notification handler code here
	FRAME frame;

	SetTestMode();
	SETHEADER(frame,m_DaAddress,SA_ADDRESS,LED_ONOFF);

	frame.LedOnOffFrame.LedNo    = 3;
	frame.LedOnOffFrame.LedOnOff = 0x00;   // LED Off
	m_slip.SendFrame(2,&frame);	
}

void CAFSKtestDlg::OnRead() 
{
	// TODO: Add your control notification handler code here
	SetConfigMode();

#if 0
	m_slip.PutStart();
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();			// Ok  
	Sleep(100);

	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('I');
	m_slip.PutChar('D');
	m_slip.PutChar('?');
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();
	Sleep(100);                 // $IDnnn  

	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('C');
	m_slip.PutChar('H');
	m_slip.PutChar('?');
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();
	Sleep(100);					// $CHnn  

	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('S');
	m_slip.PutChar('P');
	m_slip.PutChar('?');
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();			// $SPnp  
	Sleep(100);
#else
	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('?');
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();			// Version ڿ
								// $IDnnn   
								// $CHnn  
								// $SPnp  
#endif

	m_RdRfChannel = 0xFFFF;
	m_RdParity	  = 0xFFFF;
	m_RdDataRate  = 0xFFFF;
	m_RdIdentify  = 0xFFFF;
}

void CAFSKtestDlg::OnWrite() 
{
	// TODO: Add your control notification handler code here
	unsigned int num100,num10,num1;

	SetConfigMode();
	UpdateData(TRUE);

	num100 = (m_SelIdentify / 100) + '0';
	num10  = ((m_SelIdentify % 100) / 10) + '0';
	num1   = (m_SelIdentify % 10) + '0';
	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('I');
	m_slip.PutChar('D');
	m_slip.PutChar(num100);
	m_slip.PutChar(num10);
	m_slip.PutChar(num1);
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();
	Sleep(100);

	num10 = (m_SelRfChannel / 10) + '0';
	num1  = (m_SelRfChannel % 10) + '0';
	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('C');
	m_slip.PutChar('H');
	m_slip.PutChar(num10);
	m_slip.PutChar(num1);
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();
	Sleep(100);

	m_slip.PutStart();
	m_slip.PutChar('$');
	m_slip.PutChar('S');
	m_slip.PutChar('P');
	num1 = (m_SelBaudRate + 1) + '0';
	m_slip.PutChar(num1);
	if(m_SelParity == 0)
		num1 = 'N';
	else if(m_SelParity == 1)
		num1 = 'O';
	else
		num1 = 'E';
	m_slip.PutChar(num1);
	m_slip.PutChar(0x0D);
	m_slip.PutEnd();	
	Sleep(100);
}

void CAFSKtestDlg::OnDefault() 
{
	// TODO: Add your control notification handler code here
	SetConfigMode();

	m_SelBaudRate = 3;
	m_SelIdentify = 999;
	m_SelRfChannel = 15;
	m_SelParity = 0;

	UpdateData(FALSE);
}

void CAFSKtestDlg::SetConfigMode()
{
	m_OpMode = CONFIG_MODE;

	m_EchoRunStop = 1;
	OnEchorequest(); 
	SetWindowText(" :AFSKtest Ver 1.0 2011/03/18   www.wgmsk.com");
}

void CAFSKtestDlg::SetTestMode()
{
	m_OpMode = SLIP_MODE;
	SetWindowText("ۼ :AFSKtest Ver 1.0 2011/03/18   www.wgmsk.com");
}

void CAFSKtestDlg::SetUnknownMode(void)
{
	m_OpMode = UNKNOWN_MODE;
	SetWindowText("AFSKtest Ver 1.0 2011/03/18   www.wgmsk.com");
}
