// RS232.h: interface for the CRS232 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RS232_H__0C0939A1_43C0_11D4_84D9_0050DA8E82D6__INCLUDED_)
#define AFX_RS232_H__0C0939A1_43C0_11D4_84D9_0050DA8E82D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define COM1        1
#define COM2        2
#define COM3        3
#define COM4        4
#define COM5        5
#define COM6        6

#define  ASCII_XON             0x11
#define  ASCII_XOFF            0x13

#define  WM_RECEIVEDATA        (WM_USER + 10)
#define  WM_TRANSMITTDATA      (WM_USER + 11)
#define  WM_RECEIVEFRAME	   (WM_USER + 12)
	
class CRS232  
{
public:
	void PutStart(void);
	void PutEnd(void);
	BOOL fConnected;
	HWND m_hWnd;

	int  m_port;
	DWORD m_baudrate;
	int  m_databits;
	int  m_parity;
	int  m_stopbits;

	HANDLE idComDev;
	OVERLAPPED osWrite;
	OVERLAPPED osRead;

	CRS232();
	virtual ~CRS232();

	void SetCommPort(HWND hWnd,int port=COM1,DWORD baudrate = CBR_9600,int databits=8,int parit = NOPARITY,int stopbits=ONESTOPBIT);

	int CloseComPort(void);
	int OpenComPort(void);
	BOOL WriteCommBlock( LPSTR lpByte , DWORD dwBytesToWrite);
	int ReadCommBlock(LPSTR lpszBlock, int nMaxLength );
	void SetReadData(LPSTR data);
	BOOL EnableRxEvent(void);
	BOOL DisableRxEvent(void);
	BOOL EnableTxEvent(void);
	BOOL DisableTxEvent(void);

	BOOL PutChar(BYTE data);

private:
	DCB  m_PrevDCB;
	BOOL CloseConnection();
	BOOL SetupConnection();
};

#endif // !defined(AFX_RS232_H__0C0939A1_43C0_11D4_84D9_0050DA8E82D6__INCLUDED_)
