// bConfig.cpp : implementation file
//

#include "stdafx.h"
#include "afsktest.h"
#include "rs232.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CbConfig dialog


CbConfig::CbConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CbConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(CbConfig)
	m_BaudRate = 0;
	m_DataBits = 0;
	m_Identify = 0;
	m_RfChannel = 0;
	m_StopBits = 0;
	m_Parity = 0;
	//}}AFX_DATA_INIT
}


void CbConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CbConfig)
	DDX_Radio(pDX, IDC_BAUDRATE, m_BaudRate);
	DDX_Radio(pDX, IDC_DATABITS, m_DataBits);
	DDX_Text(pDX, IDC_IDENTIFY, m_Identify);
	DDV_MinMaxUInt(pDX, m_Identify, 0, 999);
	DDX_Radio(pDX, IDC_RFCHANNEL, m_RfChannel);
	DDX_Radio(pDX, IDC_STOPBITS, m_StopBits);
	DDX_Radio(pDX, IDC_PARITY, m_Parity);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CbConfig, CDialog)
	//{{AFX_MSG_MAP(CbConfig)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_BN_CLICKED(IDC_READ, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CbConfig message handlers

void CbConfig::OnWrite() 
{
	// TODO: Add your control notification handler code here
	unsigned int num100,num10,num1;

	UpdateData(TRUE);
	num100 = (m_Identify / 100) + '0';
	num10  = ((m_Identify % 100) / 10) + '0';
	num1   = (m_Identify % 10) + '0';

	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('I');
	m_pSlip->PutChar('D');
	m_pSlip->PutChar(num100);
	m_pSlip->PutChar(num10);
	m_pSlip->PutChar(num1);
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();

	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('S');
	m_pSlip->PutChar('P');
	num1 = (m_BaudRate + 1) + '0';   // '1' ~ '6'
	m_pSlip->PutChar(num1);
	if(m_Parity == 0)
		m_pSlip->PutChar('N');
	else if(m_Parity == 1)
		m_pSlip->PutChar('O');
	else
		m_pSlip->PutChar('E');
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();

	num10 = (m_RfChannel / 10) + '0';
	num1  = (m_RfChannel % 10) + '0';
	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('C');
	m_pSlip->PutChar('H');
	m_pSlip->PutChar(num10);
	m_pSlip->PutChar(num1);
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();
}

void CbConfig::OnRead() 
{
	// TODO: Add your control notification handler code here
	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('I');
	m_pSlip->PutChar('D');
	m_pSlip->PutChar('?');
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();

	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('C');
	m_pSlip->PutChar('H');
	m_pSlip->PutChar('?');
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();

	m_pSlip->PutStart();
	m_pSlip->PutChar('$');
	m_pSlip->PutChar('S');
	m_pSlip->PutChar('P');
	m_pSlip->PutChar('?');
	m_pSlip->PutChar(0x0D);
	m_pSlip->PutEnd();
}



